<?php

require ("../blogconfig/lib-blog.php");
$fnforlog=$_SERVER['SCRIPT_NAME'];

CheckID();

session_start();

require ("$blogconfigpath/lib-functions.php");
require ("$blogconfigpath/var-currentcachedir.php");
require ("$blogconfigpath/lib-tags.php");

function GoBackToFormWithError($err)
{	global $post_id;

	$_SESSION[error]=$err;
	header("Location: posteditorform.php?id=$post_id");
	exit;
}

$prevformname="posteditorform";

//An array of the variables expected to come from the form. 

	$varstoget=array("title", "filename", "category", "type", "topic", "post", "maintagstring", "othertagstring", "usefulness", "fun", "beauty", "necessity", "aesthetic", "utilit", "forfun", "educational", "news", "timesensitive", "outdated", "fav", "trivial", "important", "temphide", "clutterpile", "junkpile", "hidetime", "displaydate", "hidetitle", "notforfrontpage", "humorous", "humorousness", "nostandalone", "fullpostinrss", "excludefromrss");


	//If the previous page was an Edit page, then, the post ID 
	//will be here (delivered by a hidden field on the last page).

$post_id=$_POST[post_id];

	//This is so we can display in the title of the page what was done:

if ($post_id==0)
{	$action="Add";
}
else
{	$action="Edit";  //This means we're editing a post already in the database.  So, this means we have to figure out
						//whether or not some of the data the user input is different from the original data.
					
//We want to keep "raw" copies of the following variables, obtained prior to running the CleanInput function on $_POST,
	//since it's easier to compare the raw, non-escaped copies to the "prev" versions of those variables to ascertain 
	//whether the new data is different from the old data or not.
	
	$raw_varstomake=array("maintagstring", "othertagstring", "title", "type", "category", "post", "topic");

	foreach ($raw_varstomake as $current_var)
	{	
		$rawvarname="raw_$current_var";
		${$rawvarname}=$_POST[$current_var];
	}
	
	//Prev vars are only present if the user was editing an existing post.  So, we retrieve them here.
	//These make it possible to tell (without querying the DB) if a tagstring was changed.
	$prev_varstomake=array("maintagstring", "othertagstring");

	foreach ($prev_varstomake as $current_var)
	{	$prevvarname=substr($current_var, 0, -5); //Getting rid of "tring" at the end.
		$prevvarname="prev$prevvarname";
		${$prevvarname}=$_POST[$prevvarname];
		$_SESSION[$prevvarname]=$_POST[$prevvarname];
		${$prevvarname}=ereg_replace("&quot;", "\"", ${$prevvarname});
	}
	
	//Onward.  Most of the tag stuff is handled at the end, but some is in the middle.
}

	$len=count($varstoget);

$x=0;
while ($x<$len)
{	$varname=$varstoget[$x];
	$rawvarname="raw_" . $varname;

	$_SESSION[$varname]=$_POST[$varname];
	${$rawvarname}=$_POST[$varname];
	$x++;
} 

if (strpos($raw_category, "\"") || strpos($raw_type, "\"") )
{
	GoBackToFormWithError("catquote");
}
if (strpos($raw_category, "'") || strpos($raw_type, "'") )
{
	GoBackToFormWithError("catapos");
}


$handle=ConnectToDb();
array_walk($_POST,'CleanInput');  

$x=0;
while ($x<$len)
{	$varname=$varstoget[$x];
	${$varname}=$_POST[$varname];
	$x++;
}

array_push($varstoget, "year", "month");

//Just resetting this in case the original, uncleaned input wasn't safe:
$post_id=$_POST[post_id];

	
$tagstring_vars=array("maintagstring", "othertagstring");

$changed_tagtypes=array();

	//Then we figure out if the new raw tagstring variables are different from the previous tagstring variables,
	//and clean up any changed tagstrings.
	
foreach ($tagstring_vars as $tagstringvar)
{
	$rawtagstringvar="raw_$tagstringvar";
	if ($action=="Edit")
	{	$prevtagstringvar="prev$tagstringvar";
		$prevtagstringvar=substr($prevtagstringvar, 0, -5); //Getting rid of "tring" at the end.
	}
	$thistagtype=substr($tagstringvar, 0, -6); //Gets rid of "string" at the end.

	if ( ($action=="Edit" && ${$rawtagstringvar} != ${$prevtagstringvar} ) || ($action=="Add" && ${$rawtagstringvar} ) )
	{
		$tags_changed="true";
		${$tagstringvar}=CleanUpTagstring( ${$rawtagstringvar} );
	
		$quotelessvar="quoteless_" . $tagstringvar;		//Later on, the tagstring vars are going to end up
		${$quotelessvar}=${$tagstringvar};		//surrounded by quotes for input into the postinfo table, so we
												//want to preserve a nice, untouched copy of the cleaned-up
											//tagstrings without quotes for when we input the tags into the tags DB.
		array_push($changed_tagtypes, $thistagtype);
	}
}

if (!$filename)
{	$filename=MakeSafeFilenameString($raw_title);
}

if (!$type)
{	$type="Unspecified";
	$raw_type=$type;
}

if (!$category)
{	$category="Uncategorized";
	$raw_category=$category;
}

$nowtimestamp=GetNowTimestamp();

$nowtimestamp .= " GMT";

if ($displaydate)
{
	$displaydate=GetTimestamp($displaydate);
	$displaydate .= " GMT";
}
else
{	$displaydate=$nowtimestamp;
}

$displaygetdate=strtotime($displaydate);

$displaygetdate=getdate($displaygetdate);


$year=$displaygetdate[year];
$month=$displaygetdate[mon];


$checkboxes = array(&$aesthetic, &$utilit, &$forfun, &$educational, &$news, &$timesensitive, &$outdated, &$fav,  &$trivial, &$important, &$temphide, &$clutterpile, &$junkpile, &$hidetime, &$hidetitle, &$notforfrontpage, &$humorous, &$nostandalone, &$fullpostinrss, &$excludefromrss);

$numberboxes = array(&$usefulness, &$fun, &$beauty, &$necessity, &$humorousness);


FixCheckboxValues();
FixNumberboxValues();


function MakeQueryParts()
{	global $varstoget, $prevformname, $allqueryparts;

	$querypartstring="querypart_";

	foreach ($varstoget as $varname)
	{	
		global ${$varname};

		$sessionvarname=$prevformname . "_orig_" . $varname;

		CleanInput($_SESSION[$sessionvarname]);

		if ($_SESSION[$sessionvarname]!=${$varname} )
		{	
			$queryvarname=$querypartstring . $varname;

			${$queryvarname}="$varname =";

			$enclosedval=EncloseOrNull(${$varname}, "'");

			${$queryvarname} .= "$enclosedval, ";

			$allqueryparts .= ${$queryvarname};
		}
	}
}

$cachedir=$currentcachedir;

if ($action=="Edit")
{
	MakeQueryParts();
	TrimComma($allqueryparts);
}
else
{	EncloseOrNullAll();
}

function EncloseOrNullAll()
{	global $varstoget;
	
	foreach ($varstoget as $varname)
	{	
		global ${$varname};
		$enclosedvarname="enclosed" . $varname;
		global ${$enclosedvarname};
		${$enclosedvarname}=EncloseOrNull(${$varname}, "'");
	}
}
$bloglocationuc=ucwords($bloglocation);

echo "<html><head><title>Blog Post $post_id $action";

echo "ed</title>
<link rel=stylesheet href='a.css' type='text/css'>
</head>
<body><center>";

ListNav();

echo "<p><br><h1>Blog Post $post_id<br>$action";

echo "ed ($bloglocationuc)</h1></center>
<p>
<br>
<div id=\"maintext\">
<code>";

	$sqlvarstoget=implode(", ", $varstoget);

	echo "SQLVarstoget: $sqlvarstoget<p>";

function MakeSQLInsertVals()
{	global $varstoget, $sqlvals;
	$x=0;
	$len=count($varstoget);

	while ($x<$len)
	{	$varname=$varstoget[$x];
		global ${$varname};

		$enclosedvarname="enclosed" . $varname;

		global ${$enclosedvarname};

		$sqlvals .= "${$enclosedvarname}, ";
		$x++;
	}
	TrimComma($sqlvals);
}
MakeSQLInsertVals();

if ($action=="Add")
{	$query_to_issue = "INSERT INTO postinfo ($sqlvarstoget, whenadded, lastsaved, cachedir)";

	$query_to_issue .= " VALUES ($sqlvals, '$nowtimestamp', '$nowtimestamp', $cachedir)";

}

if ($action=="Edit")
{
	$query_to_issue="UPDATE postinfo SET lastsaved='$nowtimestamp'";
	if ($allqueryparts)
	{	$query_to_issue .= ", $allqueryparts";
	}

	$query_to_issue .= " WHERE post_id=$post_id";
}

echo $query_to_issue;

echo "</code><p>";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

if ($action=="Add")
{	
	$post_id = mysql_insert_id();
}

if ($currentcachedir==0)
{	$thiscachepath = $blogcachepath . "/$currentcachedir";
	if (!file_exists($thiscachepath) )
	{	mkdir($thiscachepath);
	}
}
	
if ($post_id%$files_per_cachedir==0)
{
	$currentcachedir=$post_id/$files_per_cachedir;

	MakeIncludeFile("var-currentcachedir.php", "currentcachedir", $currentcachedir, false, "w");

	$newcachepath = $blogcachepath . "/$currentcachedir";

	if (!file_exists($newcachepath) )
	{
		mkdir($newcachepath);
	}
}

//Now, we handle the tags.

if ($tags_changed)
{
	ManageTags("post", $post_id);
}

$raw_maintagstring=$rawmaintagstring;
$raw_othertagstring=$rawothertagstring;

echo "<p><br><br>";

$post=$raw_post;
$category=$raw_category;
$type=$raw_type;
$title=$raw_title;
$topic=$raw_topic;
$displaydate = TrimEnd($displaydate, 4);

$cachevarstoget = array("cachedir", "lastsaved", "post_id");

$cachevarstoget = array_merge($cachevarstoget, $varstoget);

$lastsaved=$nowtimestamp;

$cachefilename="postid__$post_id" . "_" . $filename;

MakePostObjectCacheFile($cachefilename, $cachedir, 0, 0);


?>